package agento

import (
	"log"
	"os"
)

var logDebug *log.Logger = log.New(os.Stdout, "d:", log.LstdFlags)
var logInfo *log.Logger = log.New(os.Stdout, "i:", log.LstdFlags)
var logWarning *log.Logger = log.New(os.Stdout, "w:", log.LstdFlags)
var logError *log.Logger = log.New(os.Stderr, "e:", log.LstdFlags)

func LogDebug(format string, v ...interface{}) {
	if logDebug == nil {
		return
	}

	logDebug.Printf(format, v...)
}

func LogInfo(format string, v ...interface{}) {
	if logInfo == nil {
		return
	}

	logInfo.Printf(format, v...)
}

func LogWarning(format string, v ...interface{}) {
	if logWarning == nil {
		return
	}

	logWarning.Printf(format, v...)
}

func LogError(format string, v ...interface{}) {
	if logError == nil {
		return
	}

	logError.Printf(format, v...)
}
