// Copyright 2010 The Go Authors. All rights reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

package cmplx64

import "github.com/AE9RB/math32"

// Rect returns the complex number x with polar coordinates r, θ.
func Rect(r, θ float32) complex64 {
	s, c := math32.Sincos(θ)
	return complex(r*c, r*s)
}
